SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[BulkEvaluationPlanQuery]
AS
BEGIN
	SET NOCOUNT ON
	
	/*
	CREATE TABLE TMP_EVALUATION_PLAN_QUERY(
		[VCC] VARCHAR(50)
		  ,[ProcessId] VARCHAR(50)
		  ,[EvaluationPlanId] VARCHAR(50)
		  ,[AudioId] VARCHAR(250)
		  ,[Section] INT
		  ,[Part] INT
		  ,[QueryId] VARCHAR(50)
		  ,[EndDate] VARCHAR(50)
		  ,[Channel] VARCHAR(50)
		  ,[Campaign] VARCHAR(50)
		  ,[CreatedDate] DATETIME
	)
	select * from TMP_EVALUATION_PLAN_QUERY ORDER BY CreatedDate DESC
	*/
	/*
	insert into TMP_EVALUATION_PLAN_QUERY (
			[VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
		  ,[CreatedDate]
		  )  
	SELECT [VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
		  ,CURRENT_TIMESTAMP
	  FROM [dbo].[#EvaluationPlanQueryTemp]
	  */
	  
	--select * from Dummy2 where AudioId = '60813629052019153349'
	--delete from Dummy2 where EvaluationPlanId <> '4f8baccd-c974-439c-b37a-0ac4ce34ada1'
	--truncate table Dummy2

	UPDATE IEP
	SET IEP.[QueryPassed] = 1
	FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
	LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
		ON EP.[Instance] = IEP.[Instance]
			AND EP.[ID] = IEP.[IdEvaluationPlan]
	LEFT JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON IEPTMP.[VCC] = IEP.[Instance]
			AND IEPTMP.[EvaluationPlanId] = IEP.[IdEvaluationPlan]
			AND IEPTMP.[AudioId] = REPLACE(IEP.[IdInteraction], ':', '_')
	WHERE IEP.[Instance] = IEPTMP.[VCC]
		AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
		AND EP.[ProcessId] = IEPTMP.[ProcessId]
		AND IEPTMP.[AudioId] IS NOT NULL;

	-- ELIMINAMOS LOS AUDIOS (INTERACCIONES) DE PROCESSAUDIO QUE NO PASARON LA VALIDACION DEL FILTRO POR CONTENIDO
	DELETE PA
	FROM [dbo].[ProcessAudio] PA
	INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON PA.[VCC] = IEPTMP.[VCC]
			AND PA.[ProcessId] = IEPTMP.[ProcessId]
			AND PA.[AudioId] = IEPTMP.[AudioId]
			AND PA.[Section] = IEPTMP.[Section]
			AND PA.[Part] = IEPTMP.[Part]
	WHERE PA.[VCC] = IEPTMP.[VCC]
		AND PA.[ProcessId] = IEPTMP.[ProcessId]
		AND PA.[AudioId] IN (
			SELECT IEP.[IdInteraction]
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
					ON IEP.[Instance] = IEPTMP.[vcc]
						AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
				LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
					ON EP.[Instance] = IEP.[Instance]
						AND EP.[ID] = IEP.[IdEvaluationPlan]
				WHERE IEP.[Instance] = IEPTMP.[VCC]
					AND IEP.[IdEvaluationPlan]  = IEPTMP.[EvaluationPlanId]
					AND EP.[ProcessId] =  IEPTMP.[ProcessId]
					AND IEP.[QueryPassed] <> 1
		)

	DELETE PAI 
		FROM [dbo].[ProcessAsyncInteraction] PAI 
		INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
			ON PAI.[VCC] = IEPTMP.[VCC]
				AND PAI.[ProcessId] = IEPTMP.[ProcessId]
				AND PAI.[InteractionId] = IEPTMP.[AudioId]
				AND PAI.[Campaign] = IEPTMP.[Campaign]
				AND PAI.[FormattedEndDate] = IEPTMP.[EndDate]
		WHERE PAI.[VCC] = IEPTMP.[VCC]
			AND PAI.[ProcessId] = IEPTMP.[ProcessId]
			AND REPLACE(PAI.[InteractionId], ':', '_' ) IN (
				SELECT IEP.[IdInteraction]
					FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
					INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
						ON IEP.[Instance] = IEPTMP.[vcc]
							AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
					LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
						ON EP.[Instance] = IEP.[Instance]
							AND EP.[ID] = IEP.[IdEvaluationPlan]
					WHERE IEP.[Instance] = IEPTMP.[VCC]
						AND IEP.[IdEvaluationPlan]  = IEPTMP.[EvaluationPlanId]
						AND EP.[ProcessId] =  IEPTMP.[ProcessId]
						AND IEP.[QueryPassed] <> 1
			)

	--UPDATE IEP SET IEP.[QueryPassed] = 0
	DELETE IEP
	FROM [dbo].[InteractionEvaluationPlan] IEP
	INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON IEP.[Instance] = IEPTMP.[VCC]
			AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
	WHERE [Instance] = IEPTMP.[VCC]
		AND [IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
		AND [QueryPassed] IS NULL;

	-- INGRESAMOS UN REGISTRO EN AUDITOREVALUATIONPLAN POR CADA INTERACCION QUE PASO EL FILTRO
	INSERT INTO [AuditorEvaluationPlan] (
		[Instance], [IdEvaluationPlan], [IdAuditor],
		[IdInteraction], [InteractionType], [InteractionDate],
		[InteractionDateEnd], [ManagementResult], [InteractionOrigin], 
		[IdAgent], [idCampaign], [InteractionDuration],
		[InteractionFormat], [TimeStamp], [Completed],
		[Score], [LastModifiedByUserId]
		)
	SELECT DISTINCT IEP.[Instance], IEP.[IdEvaluationPlan], 'SPEECH', 
		IEP.[IdInteraction], IEP.[InteractionType], IEP.[InteractionDateStart],
		CASE IEP.[InteractionType] 
			WHEN 'CALL' THEN IEP.[InteractionDateEnd]
			ELSE (
				SELECT MAX(IEP_INNER.[InteractionDateEnd])
				  FROM [InteractionEvaluationPlan] IEP_INNER (NOLOCK)
				  WHERE IEP_INNER.[IdInteraction] = IEP.[IdInteraction]
					AND IEP_INNER.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
			) END,
		STUFF((
			SELECT ',' + IEP_INNER.[ManagementResult]
				FROM [InteractionEvaluationPlan] IEP_INNER (NOLOCK)
				WHERE IEP_INNER.[IdInteraction] = IEP.[IdInteraction]
					AND IEP_INNER.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
				FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, ''),
		IEP.[InteractionOrigin],
		IEP.[IdAgent], IEP.[IdCampaign], IEP.[InteractionDuration], 
		IEP.[InteractionFormat], GETUTCDATE(), 0,
		0, 'SPEECH'
	FROM [InteractionEvaluationPlan] IEP (NOLOCK)
	INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON IEP.[Instance] = IEPTMP.[VCC]
			AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
			AND IEP.[InteractionType] = IEPTMP.[Channel]
			AND (
					(
						IEP.[InteractionType] = 'CALL'
						AND IEP.[IdInteraction] = IEPTMP.[AudioId]
						AND IEP.[InteractionSection] = IEPTMP.[Section]
						AND IEP.[InteractionPart] = IEPTMP.[Part])
					OR
					(
						IEP.[InteractionType] <> 'CALL'
						AND REPLACE(IEP.[IdInteraction], ':', '_') = IEPTMP.[AudioId]
						AND IEP.[FormattedEndDate] = IEPTMP.[EndDate]
						AND IEP.[IdCampaign] = IEPTMP.[Campaign]
					)
				)
	LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
		ON AEP.[Instance] = IEP.[Instance]
			AND AEP.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
			AND AEP.[IdInteraction] = IEP.[IdInteraction]
	WHERE IEP.[Instance] = IEPTMP.[VCC]
		AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
		AND AEP.[Instance] IS NULL

	DROP TABLE [dbo].[#EvaluationPlanQueryTemp]
	--DROP TABLE [dbo].[#EvaluationPlanQueryTemp1]
	
	SET NOCOUNT OFF
END;
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
