SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- ESTA FUNCION TIENE POR FINALIDAD ELIMINAR OTRAS EVALUACIONES PENDIENTES DE UNA INTERACCION CORRESPONDIENTES AL MISMO 
--  PLAN DE EVALUACION
CREATE PROCEDURE [dbo].[DeleteAuditorEvaluationPlanByInteraction] (
	@Instance Varchar(50) = NULL,
	@IdEvaluationPlan Varchar(50) = NULL,
	@IdInteraction Varchar(250) = NULL,
	@InteractionType Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @EvaluationPlanMode Varchar(50) = NULL

	--CONSULTAMOS LA MODALIDAD DEL PLAN DE EVALUACION
	SELECT @EvaluationPlanMode = EP.[Modality] 
		FROM [dbo].[EvaluationPlan] EP (NOLOCK)
		WHERE EP.[Instance] = @Instance
			AND EP.[ID] = @IdEvaluationPlan

	--SI ES UN PLAN DE MODALIDAD COMPARTIDA(FREE) ELIMINAMOS LAS DEMAS EVALUACIONES DE LA MISMA INTERACCION QUE EXISTEN 
	-- PARA LOS OTROS AUDITORES
	IF (@EvaluationPlanMode = 'FREE')
	BEGIN 
		DELETE
			[AuditorEvaluationPlan]
		WHERE
			[Instance] = @Instance
			AND [IdEvaluationPlan] = @IdEvaluationPlan
			AND [IdInteraction] = @IdInteraction
			AND [InteractionType] = @InteractionType
			AND ISNULL([Completed], 0) = 0
	END 

	SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
