SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[DeleteProcess] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- Verifica que exista el proceso para eliminar.
	IF EXISTS(SELECT [Name] FROM [dbo].[Process] WHERE [VCC] = @VCC AND [Name] = @Name)
	BEGIN
		-- Eliminar ProcessSummary
		DELETE FROM [dbo].[ProcessSummary]
		WHERE [VCC] = @VCC
		AND [ProcessId] = @Name

		-- Eliminar ProcessAudio
		DELETE FROM [dbo].[ProcessAudio]
		WHERE [VCC] = @VCC
		AND [ProcessId] = @Name

		-- Eliminar ProcessFilter
		DELETE FROM [dbo].[ProcessFilter]
		WHERE [VCC] = @VCC
		AND [ProcessId] = @Name

		-- Eliminar ProcessAudioSummary
		DELETE FROM [dbo].[ProcessAudioSummary]
		WHERE [VCC] = @VCC
		AND [ProcessId] = @Name

		-- Eliminar Transcription
		DELETE FROM [dbo].[Transcription]
		WHERE [VCC] = @VCC
		AND [ProcessId] = @Name

		-- Eliminar Progress
		DELETE FROM [dbo].[Progress]
		WHERE [VCC] = @VCC
		AND [ProcessId] = @Name

		-- Eliminar Process
		DELETE FROM [dbo].[Process]
		WHERE [VCC] = @VCC
		AND [Name] = @Name

		SELECT 1 AS 'result'
	END
	ELSE
	BEGIN
		SELECT 0 AS 'result'
	END
    
    SET NOCOUNT OFF
END 
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
