SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAllegroInteractionsSearch] (
   	@Instance Varchar(50) = NULL,
   	@IdAgent Varchar(MAX) = '',
   	@IdCampaign VARCHAR(MAX) = '',
 	@EvaluationDateFrom VARCHAR(MAX) = '1980-01-01',
    @EvaluationDateTo VARCHAR(MAX) = '2050-01-01',
	@InteractionMinDuration Int = 0,
    @InteractionMaxDuration Int = 100000,
    @InteractionOrigins Varchar(MAX) = '',
	
	@Ip Varchar(50), 
	@VCC Varchar(50),
	@Type Int,
	@interactionsAll BIT,
	@interactionsNothing BIT,
	@SelectedInteractions VARCHAR(MAX),
	@UnselectedInteractions VARCHAR(MAX)
)
AS 
BEGIN 

DECLARE @Sql NVARCHAR(MAX);
	DECLARE @InteractionMultimediaPartsTable NVARCHAR(100);
	DECLARE @InteractionDetailTable NVARCHAR(100);
	DECLARE @CampaignGoalResultManagementTable NVARCHAR(100);

	IF(@InteractionMinDuration = @InteractionMaxDuration AND @InteractionMaxDuration = 0)
	BEGIN
		SET @InteractionMaxDuration = 100000;
	END

	IF(@Type = 0)  
	BEGIN  
		SET @InteractionMultimediaPartsTable = '[' + @Ip + ']' + '.HistoricalData.dbo.[InteractionMultimediaParts]';
		SET @InteractionDetailTable = '[' + @Ip + ']' + '.HistoricalData.dbo.[InteractionDetail]';
		SET @CampaignGoalResultManagementTable = '[' + @Ip + ']' + '.mmprodat.dbo.[CampaignGoalResultManagement]';
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @InteractionMultimediaPartsTable = 'HistoricalData.dbo.[InteractionMultimediaParts]';
		SET @InteractionDetailTable = 'HistoricalData.dbo.[InteractionDetail]';
		SET @CampaignGoalResultManagementTable = 'mmprodat.dbo.[CampaignGoalResultManagement]';
	END  

	SET @Sql = '
		SET NOCOUNT ON
		SELECT ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)	''ID'',
			''''																								''Number'',	
			''''																								''Gender'',
			ID.[HoldTime]																						''SilenceTime'',
			ID.[DurationTime]																					''DurationTime'',
			ISNULL(CGRM.[Category1], '''')																		''Category1'',
			ISNULL(CGRM.[Category2], '''')																		''Category2'',
			ISNULL(CGRM.[Category3], '''')																		''Category3'',
			ISNULL(CGRM.[Description], '''')																	''Description'',
			ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')														''DispositionCode'',
			ID.[Campaign]																						''Campaign'',
			ID.[LastAgent]																						''Agent'',
			ID.[Direction]																						''Type'',
			CONVERT(VARCHAR, ID.[StartDate], 120)																''StartDate'',
			CONVERT(VARCHAR, ID.[EndDate], 120)																	''EndDate''
		FROM ' + @InteractionMultimediaPartsTable + ' IMP (NOLOCK)
		LEFT JOIN ' + @InteractionDetailTable + ' ID (NOLOCK) 
			ON ID.Id = IMP.Id
		LEFT JOIN ' + @CampaignGoalResultManagementTable + ' CGRM (NOLOCK) 
			ON CGRM.[VCC] = ID.[VirtualCC] 
				AND CGRM.[CampaignId] = ID.Campaign 
				AND CGRM.[Description] = ID.ManagementResult
		WHERE ID.[VirtualCC] = ''' + @VCC + '''
			AND ID.[Id] IS NOT NULL
			AND ID.[FirstAgent] IN (SELECT Value FROM [dbo].[split](''' + @IdAgent + ''','',''))
			AND ID.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @IdCampaign + ''','','')) 
			AND ID.[StartDate] >= ''' + @EvaluationDateFrom + ''' 
   			AND ID.[EndDate] <= ''' + @EvaluationDateTo + '''
			AND ID.[DurationTime] >= ' + (SELECT CONVERT(varchar(10), @InteractionMinDuration)) + '
			AND ID.[DurationTime] <= ' + (SELECT CONVERT(varchar(10), @InteractionMaxDuration)) + '
		SET NOCOUNT OFF'

	EXEC (@Sql)
	
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
