SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
--[dbo].[GetAudios] 'inconcert', 'gss_retencion_abd'
CREATE PROCEDURE [dbo].[GetAudios]
(
	@VCC								VARCHAR(50),
	@ProcessId							VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		A.[VCC]							'vcc',
		A.[ID]							'id',
		A.[Section]						'section',
		A.[Part]						'part',
		PA.[ProcessId]					'processId',
		[Number]						'number',
		[Gender]						'gender',
		[SilenceTime]					'silenceTime',
		[DurationTime]					'durationTime',
		[DurationLinguisticTime]		'durationLinguisticTime',
		[Category1]						'category1',
		[Category2]						'category2',
		[Category3]						'category3',
		[Description]					'description',
		[Campaign]						'campaign',
		[Agent]							'agent',
		[Type]							'type',
		[Init]							'init',
		[IsTranscribed]					'isTranscribed',
		PA.[CreatedDate]				'createDate',
		PA.[CreatedByUserId]			'createdByUserId',
		PA.[LastModifiedDate]			'lastModifiedDate',
		PA.[LastModifiedByUserId]		'lastModifiedByUserId'
	FROM [dbo].[Audio] A (NOLOCK)
	LEFT JOIN [ProcessAudio] PA (NOLOCK) ON A.ID = PA.AudioId AND A.Section = PA.Section AND A.Part = PA.Part
	WHERE
	A.[VCC] = @VCC
	AND PA.[ProcessId] = @ProcessId

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
