SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetAuditorEvaluationPlanEvaluation] (
	@Instance Varchar(50) = NULL,
	@AuditorId Varchar(50) = NULL,
	@EvaluationPlanId Varchar(50) = NULL,
	@InteractionId Varchar(250) = NULL,
	@InteractionType Varchar(25) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT AEP.[IdEvaluationPlan]				AS 'evaluationPlanId', 
			EP.[Evaluation_Mode]				AS 'evaluation_mode',
			AEP.[IdAuditor]						AS 'auditorId', 
			AEP.[IdInteraction]					AS 'interactionId', 
			AEP.[Completed]						AS 'evaluationCompleted', 
			EP.[Description]					AS 'evaluationPlanDescription',
			EP.[IdEvaluationFormat]				AS 'evaluationFormatId'
		FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
		LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
			ON EP.[Instance] = AEP.[Instance]
				AND EP.ID = AEP.IdEvaluationPlan
		WHERE AEP.[Instance] = @Instance 
			AND AEP.[IdEvaluationPlan] = @EvaluationPlanId 
			AND AEP.[IdAuditor] = @AuditorId 
			AND AEP.[IdInteraction] = @InteractionId
			AND AEP.[InteractionType] = @InteractionType;

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
