SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE PROCEDURE [dbo].[GetAuditors] (
	@Instance Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
 	SELECT
		t.ID							'id',
		u.lastname + ' ' + u.Firstname	'name',
		u.Firstname						'firstname',
		u.lastname						'lastname',
		u.email							'email',
		t.CreatedDate					'createdDate',
		t.CreatedByUserId				'createdByUserId',
		t.LastModifiedDate				'lastModifiedDate',
		t.LastModifiedByUserId			'lastModifiedByUserId'
	FROM Auditor t, [user] u (NOLOCK)
	WHERE
	t.Instance = @Instance
	AND u.vcc = @Instance
	AND t.id=u.ID
	AND ISNULL(t.ID, '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
 	SET NOCOUNT OFF
END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
