SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetCustomFields] (
	@VCC VARCHAR(50) = NULL, 
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	SELECT CF.[ID]							'id',
			CF.[Description]				'description',
			CF.[Label]						'label',
			CF.[Type]						'type'
	FROM [CustomField] CF (NOLOCK)
	WHERE [VCC] = @VCC
		AND ISNULL(CF.[ID], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL(CF.[Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
	ORDER BY CF.[ID] ASC

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
