SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetEvaluationCustomFieldResultsFromAuditorEvaluationPlan] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(100) = NULL,
	@InteractionId VARCHAR(250) = NULL,
	@AuditorId VARCHAR(50) = NULL,
	@AgentId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	SELECT ECFR.[VCC]								'vcc',
			ECFR.[EvaluationPlanId]					'evaluationPlanId',
			ECFR.[InteractionId]					'interactionId',
			ECFR.[AuditorId]						'auditorId',
			ECFR.[AgentId]							'agentId',
			ECFR.[CustomFieldId]					'customFieldId',
			CASE WHEN CFR.[ID] IS NULL 
				THEN ECFR.[Result] 
				ELSE CFR.[Description] END			'result'
		FROM [dbo].[EvaluationCustomFieldResult] ECFR (NOLOCK)
		LEFT JOIN [dbo].[CustomFieldResult] CFR (NOLOCK)
			ON CFR.[VCC] = ECFR.[VCC]
				AND CFR.[CustomFieldId] = ECFR.[CustomFieldId]
				AND CFR.[ID] =ECFR.[Result]
		WHERE ECFR.[VCC] = @VCC
			AND ECFR.[EvaluationPlanId] = @EvaluationPlanId
			AND ECFR.[InteractionId] = @InteractionId
			AND ECFR.[AuditorId] = @AuditorId
			AND ECFR.[AgentId] = @AgentId
			--AND ECFR.[CustomFieldId] = ''

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
