SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetEvaluationFormatDescriptionsBySearchCriteria] (
	@Instance Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT DISTINCT
		E.[ID]							'id',
		[Description]					'description',
		[Type]							'type',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM [EvaluationFormat] E, [AbilityEvaluationFormat] A (NOLOCK)
	WHERE E.ID = A.IdEvaluationFormat
	AND E.[Instance] = @Instance
	AND A.[Instance] = @Instance
	AND ISNULL(A.IdAbility, '') LIKE CASE WHEN @SearchCriteria = 'idAbility' THEN '%' + @SearchExpression + '%' ELSE '%' END
	AND ISNULL(A.IdGroup, '') LIKE CASE WHEN @SearchCriteria = 'idGroup' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END
	AND ISNULL(A.IdSubGroup, '') LIKE CASE WHEN @SearchCriteria = 'idSubGroup' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END

	SET NOCOUNT OFF
END

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
