SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetEvaluationPlanCognitiveTask] (
    @VCC Varchar(50) = NULL, @ID Varchar(50) = NULL
)
AS
BEGIN
SET NOCOUNT ON

	SELECT DISTINCT
			A.Instance			'vcc'
			,A.ProcessId		'processId'
			,A.[Id]				'evaluationPlanId'
			,B.IdInteraction	'id'
			,C.Section			'section'
			,C.Part				'part'
			,F.nluId			'nluId'
			,F.appId			'appId'
			,C.[FileName]		'fileName'
			,F.[cognitiveId]
	FROM [EvaluationPlan] A (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] B (NOLOCK) 
		ON A.Instance = B.Instance 
			AND A.Id = B.IdEvaluationPlan
	INNER JOIN [dbo].[Audio] C WITH (NOLOCK) 
		ON A.Instance = C.VCC 
			AND B.IdInteraction = C.ID 
	INNER JOIN [AbilityEvaluationFormat] D 
		ON A.Instance = D.Instance 
			AND A.IdEvaluationFormat = D.IdEvaluationFormat
	INNER JOIN [Ability] E 
		ON A.Instance = E.Instance 
			AND D.IdAbility = E.ID 
			AND E.QueryName IS NOT NULL
	INNER JOIN (SELECT DISTINCT
				A.VCC 'vcc'
				,A.[Name] + '|'+ B.[Name] 'cognitiveId'
				,A.[Name] 'nluId'
				,A.AppId 'appId'
				,B.[IntentId] 'intentId',B.Name
			FROM NLU A (NOLOCK)
			INNER JOIN Intent B (NOLOCK) 
				ON A.VCC = B.VCC
					AND B.AppId = A.AppId) F 
		ON A.Instance = F.VCC 
			--AND E.ID = F.cognitiveId
			AND E.Query = F.cognitiveId
			AND E.QueryName = F.intentId
	WHERE A.[Instance] = @VCC
		AND A.[ID] = @ID

SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
