SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- ESTE SP RETORN LAS TRANSCRIPCIONES DE UNA INTERACCION SEGUN SU VCC, INTERACTIONTYPE(CHANNEL), INTERACTIONID
CREATE PROCEDURE [dbo].[GetEvaluationPlanInteractionByTypeAndId] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- RECUPERAMOS EL PRIMER REGISTRO POR ID DE INTERACCION
	SELECT TOP 1 IEP.[Instance]									AS 'vcc',
					IEP.[IdAgent]								AS 'descriptionAgent',
					''											AS 'descriptionAuditor',
					IEP.[IdCampaign]							AS 'descriptionCampaign',
					EP.[Description]							AS 'descriptionEvaluationPlan',
					IEP.[InteractionDateStart]					AS 'dateIni',
					IEP.[InteractionDateEnd]					AS 'dateFin',
					IEP.[IdInteraction]							AS 'id',
					IEP.[IdAgent]								AS 'idAgent',
					''											AS 'idAuditorEvaluationPlan',
					IEP.[IdCampaign]							AS 'idCampaign',
					IEP.[IdEvaluationPlan]						AS 'idEvaluationPlan',
					IEP.[InteractionType]						AS 'interactionType',
					IEP.[InteractionDuration]					AS 'interactionTime',
					A.[DurationLinguisticTime]					AS 'interactionValidTime',
					''											AS 'origin',
					IEP.[InteractionMessages]					AS 'totalMessages',
					A.[Number]									AS 'number'
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
			ON EP.[Instance] = IEP.[Instance]
				AND EP.[ID] = IEP.[IdEvaluationPlan]
		LEFT JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = IEP.[Instance]
				AND A.[ID] = IEP.[IdInteraction]
				AND A.[Section] = IEP.[InteractionSection]
				AND A.[Part] = IEP.[InteractionPart]
		WHERE IEP.[Instance] = @VCC
			AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
			AND IEP.[InteractionType] = @InteractionType
			AND IEP.[IdInteraction] = @InteractionId

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
