SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE  PROCEDURE [dbo].[GetEvaluationPlans] (
@Instance           Varchar(50) = NULL,
@SearchCriteria     Varchar(50) = NULL,
@SearchExpression   Varchar(50) = NULL,
@Disabled			bit = NULL
)
AS
BEGIN
SET NOCOUNT ON

    SELECT
    e.[ID]							'id',
    e.[Modality]					'modality',
    e.[DateFin]						'dateFin',
    e.CreatedDate					'createdDate',
    e.CreatedByUserId				'createdByUserId',
    e.LastModifiedDate				'lastModifiedDate',
    e.LastModifiedByUserId			'lastModifiedByUserId',
    e.Description					'description',
    e.IdEvaluationFormat            'idEvaluationFormat',
    e.Enabled						'enabled',
    e.Status						'status',
    e.Evaluation_Mode				'evaluation_mode',
    e.processId    				    'processId',
    ef.templateId    				'templateId',
    count(a.IdInteraction)			'totalEvaluations',
    ISNULL(sum(cast(a.Completed as int)), 0)   'completedEvaluations',
    ISNULL(ROUND(sum(cast(a.Completed as numeric(5,2)))*100/count(a.IdInteraction),2), 0) 'completedPercentage',
	e.[Percentage]					'percentage',
	e.[StatusDescription]			'statusDescription',
	e.[BatchStatus]					'batchStatus'
FROM EvaluationPlan e (NOLOCK)
LEFT JOIN AuditorEvaluationPlan a (NOLOCK) 
	ON a.[Instance] = e.[Instance]
		AND a.[IdEvaluationPlan] = e.[ID]
LEFT JOIN EvaluationFormat ef (NOLOCK)
	ON ef.[Instance] = e.[Instance]
		AND ef.[ID] = e.[IdEvaluationFormat]
WHERE e.Instance = @Instance
	AND ISNULL(e.Description, '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
    AND ISNULL(e.Modality, '') LIKE CASE WHEN @SearchCriteria = 'modality' THEN '%' + @SearchExpression + '%' ELSE '%' END
    AND ISNULL(@Disabled, 0) <> e.Enabled
GROUP BY e.[ID],e.[Modality],e.[DateFin],e.CreatedDate,e.CreatedByUserId,
         e.LastModifiedDate,e.LastModifiedByUserId,e.Description,e.IdEvaluationFormat,
		 e.Enabled, e.Status, e.Evaluation_Mode,e.processId,ef.templateId, 
		 e.Percentage, e.StatusDescription, e.[BatchStatus]	
/*
    , AuditorEvaluationPlan a, EvaluationFormat ef (NOLOCK)
WHERE
    e.Instance = @Instance
    AND e.IdEvaluationFormat=ef.id
    AND a.IdEvaluationPlan=e.ID
    -- AND ISNULL(e.Status, '') LIKE CASE WHEN @SearchCriteria = 'status' THEN '%' + @SearchExpression + '%' ELSE '%' END
    AND ISNULL(e.Description, '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
    AND ISNULL(e.Modality, '') LIKE CASE WHEN @SearchCriteria = 'modality' THEN '%' + @SearchExpression + '%' ELSE '%' END
    AND ISNULL(@Disabled, 0) <> e.Enabled
GROUP BY e.[ID],e.[Modality],e.[DateFin],e.CreatedDate,e.CreatedByUserId,
         e.LastModifiedDate,e.LastModifiedByUserId,e.Description,e.IdEvaluationFormat,e.Enabled, e.Status, e.Evaluation_Mode,e.processId,ef.templateId
*/
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
