SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetExceptions] (
	@VCC Varchar(50) = NULL , @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		e.VCC							'vcc',
		e.ID							'id', 
		e.Description					'description',
		e.CreatedDate					'createdDate',
		e.CreatedByUserId				'createdByUserId',
		e.LastModifiedDate  			'lastModifiedDate',
		e.LastModifiedByUserId			'lastModifiedByUserId',
		e.TimeStamp						'timeStamp'
	FROM Exception e (NOLOCK)
	WHERE e.VCC = @VCC
		AND ISNULL(e.ID, '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL(e.Description, '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END
	ORDER BY e.[Description]

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
