SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[GetInteractionTypes] (
	@Instance Varchar(50) = NULL,
	@SearchCriteria Varchar(50) = NULL,
	@SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
 	SELECT
		t.Instance						'instance',
		t.ID							'id',
		t.Description					'description'

	FROM InteractionType t (NOLOCK)
	WHERE
	t.Instance = @Instance
	AND ISNULL(t.ID, '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
	AND ISNULL(t.Description, '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END

 	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
