SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
--[GetInteractionsCognitive] 'allegro', 'test1', 'testnluprimero'
CREATE PROCEDURE [dbo].[GetInteractionsCognitive]
(
	@VCC				VARCHAR(50),
	@ProcessId			VARCHAR(50),
	@StudyId			VARCHAR(200)
)
AS
BEGIN
	SET NOCOUNT ON

		SELECT DISTINCT
			A.VCC				'vcc'
			,A.ProcessId		'processId'
			,A.[Name]			'studyId'
			,D.AudioId			'id'
			,D.Section			'section'
			,D.Part				'part'
			,B.TemplateId		'templateId'
			,C.nluId			'nluId'
			,C.appId			'appId'
			,E.[FileName]		'fileName'
		FROM [dbo].[Study] A (NOLOCK)
		INNER JOIN [dbo].[TemplateThemeItem] B (NOLOCK) 
			ON A.VCC = B.VCC 
				AND A.[TemplateId] = B.[TemplateId]
		INNER JOIN (SELECT DISTINCT
				A.VCC 'vcc'
				,A.[Name] + '|'+ B.[Name] 'cognitiveId'
				,A.[Name] 'nluId'
				,A.AppId 'appId'
			FROM NLU A (NOLOCK)
			INNER JOIN Intent B (NOLOCK) 
				ON A.VCC = B.VCC
					AND B.AppId = A.AppId) C 
			ON A.VCC = C.VCC 
				AND B.ID = C.cognitiveId
		INNER JOIN [dbo].[ProcessAudio] D (NOLOCK) 
			ON A.VCC = D.VCC 
				AND A.ProcessId = D.ProcessId
		INNER JOIN [dbo].[Audio] E (NOLOCK) 
			ON A.VCC = E.VCC 
				AND D.AudioId = E.ID 
				AND D.Section = E.Section 
				AND D.Part = E.Part
		WHERE A.[VCC] = @VCC
			AND A.[ProcessId] = @ProcessId
			AND A.[Name] = @StudyId


	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
