SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
/*
Los estados son:
NotStarted	=	0% (Default)
Audios		=	20% (Mover audios)
InProcess	=	70% (Procesado en SpeechMatics)
Completed	=	100% (Procesado en IDATHA)
*/
-- [dbo].[GetProcessByStatus] 'default', 'Completed'
CREATE PROCEDURE [dbo].[GetProcessByStatus]
(
	@VCC								VARCHAR(50),
	@Status								VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	SELECT
		A.[VCC]							'vcc',
		A.[Description]					'description',
		A.[ClientId]					'clientId',
		A.[Status]						'status',
		A.[StartDate]					'startDate',
		A.[EndDate]						'endDate',
		A.[MinDurationTime]				'minDurationTime',
		A.[MaxDurationTime]				'maxDurationTime',
		A.[Environment]					'environment',
		A.[CreatedDate]					'createdDate',
		A.[CreatedByUserId]				'createdByUserId',
		A.[LastModifiedDate]			'lastModifiedDate',
		A.[LastModifiedByUserId]		'lastModifiedByUserId',
		B.[UserName]					'userName',
		B.[Password]					'password',
		B.[Realm]						'realm'
	FROM [Process] A (NOLOCK)
	INNER JOIN [IdathaAuth] B ON A.[Name] = B.Realm
	WHERE A.[VCC] = @VCC
	AND A.[Status] = @Status
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
