SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetReport] (
	@VCC Varchar(50) = NULL, @ID Varchar(50) = NULL, @Role Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	IF(@Role IS NULL)
	BEGIN
		SELECT
			[ID]								'id',
			[Description] 						'description',
			[Procedure] 						'procedure',
			[StartDate]							'startDate',
			[EndDate]							'endDate',
			[Frecuency]							'frecuency',
			[HourSpace]							'hourSpace',
			[ExactTime]							'exactTime',
			[Weekday]							'weekday',
			[DayMonth]							'dayMonth',
			[Summary]							'summary',
			[Filter]							'filter',
			[Email]								'email',
			[Type]								'type'
		FROM [Report] (NOLOCK)
		WHERE [VCC] = @VCC
		AND ([Type] IN (SELECT [Product] FROM VCCLicense (NOLOCK)  WHERE [VCC] = @VCC AND [Status] = 1) OR [Type] = 'SHARED')
		AND [ID] = @ID
	END
	ELSE IF (@Role = 'business_administrator')
	BEGIN
		SELECT
			[ID]								'id',
			[Description] 						'description',
			[Procedure] 						'procedure',
			[StartDate]							'startDate',
			[EndDate]							'endDate',
			[Frecuency]							'frecuency',
			[HourSpace]							'hourSpace',
			[ExactTime]							'exactTime',
			[Weekday]							'weekday',
			[DayMonth]							'dayMonth',
			[Summary]							'summary',
			[Filter]							'filter',
			[Email]								'email',
			[Type]								'type'
		FROM [Report] (NOLOCK)
		WHERE [VCC] = @VCC
		AND [Type] IN ('BILLING', 'BUSINESS') 
		AND [ID] = @ID
	END
	ELSE IF @Role = 'provisioning'
	BEGIN 
		SELECT
			[ID]								'id',
			[Description] 						'description',
			[Procedure] 						'procedure',
			[StartDate]							'startDate',
			[EndDate]							'endDate',
			[Frecuency]							'frecuency',
			[HourSpace]							'hourSpace',
			[ExactTime]							'exactTime',
			[Weekday]							'weekday',
			[DayMonth]							'dayMonth',
			[Summary]							'summary',
			[Filter]							'filter',
			[Email]								'email',
			[Type]								'type'
		FROM [Report] (NOLOCK)
		WHERE  [VCC] = @VCC
		AND [Type] IN ('BILLING') 
		AND [ID] = @ID
	END
	
	
	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
