SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetRoleRoutePermission] (
	@VCC Varchar(50) = NULL, @RoleId Varchar(50) = NULL, @License Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT rp.[ID]							    'routeId',
			rp.[Route] 							'route',
			rp.[Level] 							'level',
			rp.[GroupId] 							'groupId'
	FROM [RoutePermission] rp (NOLOCK)
	LEFT JOIN RolePermissionsGroup rpg (NOLOCK)
		ON rpg.GroupId = rp.[GroupId]
	WHERE rp.[VCC] = @VCC
		AND ( @License IS NULL OR rpg.Type in( @License,'SHARED') )
		AND rp.[GroupId] IN (
			SELECT [GroupId]
			FROM [RolePermission] (NOLOCK)
			WHERE [VCC] = @VCC		
			AND [RoleId] = CASE WHEN ISNULL(@RoleId, '') = '' THEN [RoleId] ELSE @RoleId END
		
		)
	GROUP BY rp.[ID], rp.[Route],rp.[Level],rp.GroupId
	ORDER BY rp.[GroupId], rp.[ID] ASC
	

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
