SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetRoles] (
	@VCC Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @License VARCHAR(50) = NULL
	IF((SELECT COUNT(*) FROM VCCLicense WHERE VCC =@VCC) = 1)
	BEGIN
	SET @License = (SELECT Product FROM VCCLicense WHERE VCC =@VCC)
	END
	

	SELECT
		[ID]							'id',
		[Description]					'description',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId',
		[SystemRole]					'systemRole',
		[Type]							'type'
	FROM [Role] (NOLOCK)
	WHERE [VCC] = @VCC
	AND ( @License IS NULL OR [Type] in( @License,'SHARED') or [Type] is null )
	AND ISNULL([ID], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
	AND ISNULL([Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
