SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

--[GetStudyCognitiveTask] 'allegro', 'test1', 'testnluprimero'
CREATE PROCEDURE [dbo].[GetStudyCognitiveInteractionsTask]
(
	@VCC				VARCHAR(50),
	@ProcessId			VARCHAR(50),
	@StudyId			VARCHAR(200)
)
AS
BEGIN
	SET NOCOUNT ON
	
		SELECT DISTINCT
			A.VCC						'vcc'
			,A.ProcessId				'processId'
			,E.[Campaign]				'campaign'
			,'CALL'						'interactionType'
			,A.[Name]					'studyId'
			,D.AudioId					'id'
			,D.Section					'section'
			,D.Part						'part'
			,B.TemplateId				'templateId'
			,C.nluId					'nluId'
			,C.appId					'appId'
			,E.[FileName]				'fileName'
			,V.[CognitiveEngine]		'cognitiveEngine'
		FROM [dbo].[Study] A (NOLOCK)
		INNER JOIN [dbo].[TemplateThemeItem] B (NOLOCK) 
			ON A.VCC = B.VCC 
				AND A.[TemplateId] = B.[TemplateId]
		INNER JOIN (
			SELECT DISTINCT
					A.VCC 'vcc'
					,A.[Name] + '|'+ B.[Name] 'cognitiveId'
					,A.[Name] 'nluId'
					,A.AppId 'appId'
				FROM NLU A (NOLOCK)
				INNER JOIN Intent B (NOLOCK) 
					ON A.VCC = B.VCC
						AND B.AppId = A.AppId
		) C 
			ON A.VCC = C.VCC 
				AND B.ID = C.cognitiveId
		INNER JOIN [dbo].[ProcessAudio] D (NOLOCK) 
			ON A.VCC = D.VCC 
				AND A.ProcessId = D.ProcessId
		INNER JOIN [dbo].[Audio] E (NOLOCK) 
			ON A.VCC = E.VCC 
				AND D.AudioId = E.ID 
				AND D.Section = E.Section 
				AND D.Part = E.Part
				AND E.[IsTranscribed] = 1
		LEFT JOIN [dbo].[VCC] V (NOLOCK)
			ON V.[ID] = A.[VCC]
		WHERE A.[VCC] = @VCC
			AND A.[ProcessId] = @ProcessId
			AND A.[Name] = @StudyId




		SELECT DISTINCT
			S.VCC															'vcc'
			,S.ProcessId													'processId'
			,AI.[Campaign]													'campaign'
			,AI.[Channel]													'interactionType'
			,S.[Name]														'studyId'
			,AI.[ID]														'id'
			,AI.[EndDate]													'endDate'
			,AI.[Folder]													'folder'
			,AI.[DispositionCode]											'dispositionCode'
			,ISNULL(AI.[LastTakedAgent], AI.[FirstTakedAgent])				'agent'
			,AI.[Initiative]												'origin'
			,AI.[TotalMessages]												'totalMessages'
			,AI.[RawChar]													'rawChar'
			,TTI.TemplateId													'templateId'
			,SEL_01.nluId													'nluId'
			,SEL_01.appId													'appId'
			,AI.[FileName]													'fileName'
			,V.[CognitiveEngine]											'cognitiveEngine'
		FROM [dbo].[Study] S (NOLOCK)
		INNER JOIN [dbo].[TemplateThemeItem] TTI (NOLOCK) 
			ON S.VCC = TTI.VCC 
				AND S.[TemplateId] = TTI.[TemplateId]
		INNER JOIN (
			SELECT DISTINCT
					A.VCC 'vcc'
					,A.[Name] + '|' + B.[Name] 'cognitiveId'
					,A.[Name] 'nluId'
					,A.AppId 'appId'
				FROM NLU A (NOLOCK)
				INNER JOIN Intent B (NOLOCK) 
					ON A.VCC = B.VCC
						AND B.AppId = A.AppId
		) SEL_01 
			ON S.VCC = SEL_01.VCC 
				AND TTI.ID = SEL_01.cognitiveId
		INNER JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			ON PAI.[VCC] = S.[VCC]
				AND PAI.[ProcessId] = S.[ProcessId]
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[VCC] = S.[VCC]
				AND AI.[Campaign] = PAI.[Campaign]
				AND AI.[Channel] = PAI.[InteractionType]
				AND AI.[ID] = PAI.[InteractionId]
				AND AI.[Folder] = PAI.[FormattedEndDate]
		LEFT JOIN [dbo].[VCC] V (NOLOCK)
			ON V.[ID] = S.[VCC]
		WHERE S.[VCC] = @VCC
			AND S.[ProcessId] = @ProcessId
			AND S.[Name] = @StudyId
			AND AI.[IsTranscribed] = 1

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
