SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

-- [dbo].[GetTags] 'default', '{00c7211a-973a-11e8-87f3-be2929e88805}', 0, 0
CREATE PROCEDURE [dbo].[GetTags]
(
	@VCC						VARCHAR(50),
	@AudioId					VARCHAR(50),
	@Section					NUMERIC(5, 0),
	@Part						NUMERIC(5, 0)
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]												'vcc',
		[AudioId]											'audioId',
		[Section]											'section',
		[Part]												'part',
		STR([CurrentTime], 18, 18)							'currentTime',
		[Tag]												'tag',
		[Comment]											'comment',
		[CreatedDate]										'createdDate',
		[CreatedByUserId]									'createdByUserId',
		[LastModifiedDate]									'lastModifiedDate',
		[LastModifiedByUserId]								'lastModifiedByUserId',
		[TimeStamp]											'timeStamp'
	FROM
		[dbo].[Tag] (NOLOCK)
	WHERE
		[VCC] = @VCC AND
		[AudioId] = @AudioId AND
		[Section] = @Section AND
		[Part] = @Part

	SET NOCOUNT OFF
END 
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
