SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetUniqueNLUByIntents]
(
	@VCC					VARCHAR(50),
	@TemplateId				VARCHAR(50),
	@Intents				VARCHAR(MAX)
)
AS
BEGIN
	SET NOCOUNT ON

	-- ESTA FUNCION ES USADA SOLO PARA FORMATOS DE EVALUACION
	SELECT DISTINCT F.[AppId]			'appId' 
		FROM [dbo].[EvaluationFormat] EF (NOLOCK)
		INNER JOIN [AbilityEvaluationFormat] AEF (NOLOCK)
			ON EF.[Instance] = AEF.[Instance] 
				AND EF.[ID] = AEF.[IdEvaluationFormat]
		INNER JOIN [Ability] A (NOLOCK) 
			ON EF.[Instance] = A.[Instance] 
				AND AEF.IdAbility = A.[ID] 
				AND A.[QueryName] IS NOT NULL
		INNER JOIN (SELECT DISTINCT
					N.[VCC]									'vcc'
					,N.[Name] + '|'+ I.[Name]				'cognitiveId'
					,N.[Name]								'nluId'
					,N.[AppId]								'appId'
					,I.[IntentId]							'intentId'
					, I.[Name]
				FROM [dbo].[NLU] N (NOLOCK)
				INNER JOIN [dbo].[Intent] I (NOLOCK) 
					ON N.[VCC] = I.[VCC]
						AND I.[AppId] = N.[AppId]
				WHERE N.[VCC] = @VCC
					AND I.[IntentId] IN (SELECT Value FROM dbo.[SplitString](@Intents, ','))) F 
			ON EF.[Instance] = F.[VCC] 
				--AND E.ID = F.cognitiveId
				AND A.[Query] = F.[cognitiveId]
				AND A.[QueryName] = F.[intentId]
		WHERE EF.[Instance] = @VCC
			AND EF.[templateId] = @TemplateId

	/*
	SELECT
		DISTINCT I.[AppId]			'appId'
	FROM
		[dbo].[Intent] I (NOLOCK) 
	WHERE
		I.[VCC] = @VCC
		AND I.[IntentId] IN (SELECT Value FROM dbo.[SplitString](@Intents, ','))
	*/

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
