SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[GetUsers] (
	@VCC Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- LISTAMOS LOS USUARIOS SEGUN LOS CRITERIOS DE BUSQUEDA Y NO SEAN USUARIOS DEL SISTEMA
	SELECT
		[ID]								'id',
		[Email] 							'email',
		[Firstname] 						'firstname',
		[Lastname] 							'lastname',
		[Role] 								'role',
		[Country] 							'country',
		[Language] 							'language',
		[TimeZone] 							'timeZone',
		[Preferences] 						'preferences',
		[IsSystemUser] 						'isSystemUser',
		[API]								'api',
		[CreatedDate]						'createdDate',
		[CreatedByUserId]					'createdByUserId',
		[LastModifiedDate]					'lastModifiedDate',
		[LastModifiedByUserId]				'lastModifiedByUserId'
	FROM [User] (NOLOCK)
	WHERE [VCC] = @VCC
		AND [IsSystemUser] = 0 
		AND ISNULL([ID], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL([Firstname], '') + ' ' + ISNULL([Lastname], '') LIKE CASE WHEN @SearchCriteria = 'name' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL([Role], '') LIKE CASE WHEN @SearchCriteria = 'role' THEN '%' + @SearchExpression + '%' ELSE '%' END
	
	SET NOCOUNT OFF
END 
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
