SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
-- [dbo].[GetUtterancesByIntentId] 'allegro', '45799dd8-17e7-49a1-9bd8-cb74f00a788c'
CREATE PROCEDURE [dbo].[GetUtterancesByIntentId]
(
	@VCC			VARCHAR(50),
	@IntentId		VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]							'vcc',
		[AppId]							'appId',
		[IntentId]						'intentId',
		[AudioId]						'audioId',
		[Section]						'section',
		[Part]							'part',
		[Speaker]						'speaker',
		[AnchorOffset]					'anchorOffset',
		[FocusOffset]					'focusOffset',
		[CurrentTime]					'currentTime',
		[EndCurrentTime]				'endCurrentTime',
		[UtteranceId]					'utteranceId',
		[TextContent]					'textContent',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM
		[dbo].[Utterance] WITH (NOLOCK)
	WHERE
		[VCC] = @VCC
		AND [IntentId] = @IntentId

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
