SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveDomain] (
	@VCC Varchar(50) = NULL, 					    @Domain Varchar(50) = NULL,						@Description Varchar(200) = NULL,
	@Client Varchar(50) = NULL,						@HasHttps Bit = NULL,							@ContentPort Varchar(50) = NULL,
	@Prefix Varchar(100) = NULL,					@IsMainDomain Bit = NULL,						@IsContentDomain Bit = NULL,
	@ContentDefaultRedirect Varchar(50) = NULL,		@IsDistributedService Bit = NULL,				@AssociatedDistributedService Varchar(50) = NULL,
	@CustomCode Varchar(MAX) = NULL,				@CreatedDate Datetime = NULL,					@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,				@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [Domain]
	SET [Description] = @Description,
		[Client] = @Client,
		[HasHttps] = @HasHttps,
		[ContentPort] = @ContentPort,
		[Prefix] = @Prefix,
		[IsMainDomain] = @IsMainDomain,
		[IsContentDomain] = @IsContentDomain,
		[ContentDefaultRedirect] = @ContentDefaultRedirect,
		[IsDistributedService] = @IsDistributedService,
		[AssociatedDistributedService] = @AssociatedDistributedService,
		[CustomCode] = @CustomCode,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [Domain] = @Domain

    IF @@ROWCOUNT = 0
		INSERT INTO [Domain] (
			[VCC], [Domain], [Description],
			[Client], [HasHttps], [ContentPort],
			[Prefix], [IsMainDomain], [IsContentDomain],
			[ContentDefaultRedirect], [IsDistributedService], [AssociatedDistributedService],
			[CustomCode], [CreatedDate], [CreatedByUserId],
			[LastModifiedDate], [LastModifiedByUserId],
			[TimeStamp]
			)
		VALUES (
			@VCC, @Domain, @Description,
			@Client, @HasHttps, @ContentPort,
			@Prefix, @IsMainDomain, @IsContentDomain,
			@ContentDefaultRedirect, @IsDistributedService, @AssociatedDistributedService,
			@CustomCode, @CreatedDate, @CreatedByUserId,
			@LastModifiedDate, @LastModifiedByUserId, GETUTCDATE()
		)
		
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
