SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveEvaluationCustomFieldResult] (
	@VCC VARCHAR(50) = NULL, 				
	@EvaluationPlanId VARCHAR(100) = NULL,
	@InteractionId VARCHAR(250) = NULL,
	@AuditorId VARCHAR(50) = NULL,					
	@AgentId VARCHAR(50) = NULL,
	@CustomFieldId VARCHAR(100) = NULL,
	@Result VARCHAR(100) = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [EvaluationCustomFieldResult]
		SET [Result] = @Result,
			[LastModifiedDate] = GETUTCDATE(),
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [EvaluationPlanId] = @EvaluationPlanId
			AND [InteractionId] = @InteractionId
			AND [AuditorId] = @AuditorId
			AND [AgentId] = @AgentId
			AND [CustomFieldId] = @CustomFieldId

    IF @@ROWCOUNT = 0
		INSERT INTO [EvaluationCustomFieldResult] (
			[VCC], 
			[EvaluationPlanId],
			[InteractionId], 
			[AuditorId], 
			[AgentId],
			[CustomFieldId],
			[Result],
			[CreatedDate],
			[CreatedByUserId],
			[TimeStamp]
		)
		VALUES (
			@VCC, 
			@EvaluationPlanId,
			@InteractionId,
			@AuditorId,
			@AgentId,
			@CustomFieldId,
			@Result,
			GETUTCDATE(),
			@CreatedByUserId,
			GETUTCDATE()
		)

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
