SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveIntegratedUser] (
	@VCC Varchar(50) = NULL, 					@ID Varchar(50) = NULL, 				@Email Varchar(50) = NULL,
	@Firstname Varchar(50) = NULL, 				@Lastname Varchar(50) = NULL, 			@Password Varchar(50) = NULL,
	@Role Varchar(50) = NULL, 					@Country Varchar(50) = NULL, 			@Language Varchar(50) = NULL,
	@TimeZone Varchar(50) = NULL,				@Preferences Varchar(200) = NULL, 		@IsSystemUser Bit = NULL,
	@LimitClients Bit = NULL,					@CreatedDate Datetime = NULL,			@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,			@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	IF EXISTS(
	SELECT [VCC], [ID] FROM [User] (NOLOCK)
	WHERE [VCC] = @VCC
	AND [ID] = @ID
	)
	BEGIN
		SELECT 1 AS 'result'
	END 
    ELSE
	BEGIN

		IF EXISTS (SELECT [Country] FROM CountryParser (NOLOCK) WHERE [CountryId] = @Country)
		BEGIN
			SET @Country = (SELECT [Country] FROM CountryParser (NOLOCK) WHERE [CountryId] = @Country)
		END
		ELSE
		BEGIN
			SET @Country = NULL;
		END

		IF EXISTS (SELECT [TimeZone] FROM TimeZoneParser (NOLOCK) WHERE [TimeZoneId] = @TimeZone)
		BEGIN
			SET @TimeZone = (SELECT [TimeZone] FROM TimeZoneParser (NOLOCK) WHERE [TimeZoneId] = @TimeZone)
		END
		ELSE
		BEGIN
			SET @TimeZone = NULL;
		END

		INSERT INTO [User] (
			[VCC], [ID], [Email],
			[Firstname], [Lastname], [Password],
			[Role], [Country], [Language],
			[TimeZone], [Preferences], [IsSystemUser],
			[LimitClients], [CreatedDate], [CreatedByUserId],
			[LastModifiedDate], [LastModifiedByUserId],
			[TimeStamp]
			)
		VALUES (
			@VCC, @ID, @Email,
			@Firstname, @Lastname, @Password,
			@Role, @Country, @Language,
			@TimeZone, @Preferences, @IsSystemUser,
			@LimitClients, @CreatedDate, @CreatedByUserId,
			@LastModifiedDate, @LastModifiedByUserId,
			GETUTCDATE()
		)
		SELECT 1 AS 'result'
	END	
   
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
