SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveInteractionEvaluationPlanResult] (
	@Instance Varchar(50),
	@IdEvaluationPlan Varchar(50),
	@IdAuditor Varchar(50),
	@IdInteraction Varchar(250),
	@InteractionType Varchar(50),
	@Score numeric(5,2),
	@AutomaticScore NUMERIC(5,2),
	@ManualScore NUMERIC(5,2)
	)
AS
BEGIN
	SET NOCOUNT ON
 	UPDATE AuditorEvaluationPlan
		SET [Completed] = 1, 
			[Score] = @Score, 
			[AutomaticScore] = @AutomaticScore,
			[ManualScore] = @ManualScore,
			[LastModifiedDate] = GETUTCDATE(),
			[TimeStamp] = GETUTCDATE()
		WHERE [Instance] = @Instance
			AND [IdEvaluationPlan] = @IdEvaluationPlan
			AND [IdInteraction] = @IdInteraction
			AND [InteractionType] = @InteractionType
			AND [IdAuditor] = @IdAuditor

    SELECT 1 AS 'result'

 	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
