SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveSinglePermission] (
	@VCC Varchar(50) = NULL, @Type Varchar(50) = NULL, @Element Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN TRY

        DECLARE @Result Int = 1

        UPDATE [SinglePermission] SET
            [TimeStamp] = GETUTCDATE()
        WHERE [VCC] = @VCC
        AND [GroupId] = 'SINGLE_PERM_' + @Type + '_' + @Element
        AND [Type] = @Type
        AND [Element] = @Element

        IF @@ROWCOUNT = 0
            INSERT INTO [SinglePermission] (
                [VCC], [ID], [GroupId],
                [Type], [Element],
                [TimeStamp]
            )
            SELECT TOP 1 
                @VCC, CONVERT(VARCHAR(50), CAST([ID] AS Int) + 1), 'SINGLE_PERM_' + @Type + '_' + @Element,
                @Type, @Element,
                GETUTCDATE()
            FROM [SinglePermission] (NOLOCK)
            ORDER BY CAST([ID] AS Int) DESC

        UPDATE [RolePermissionsGroup] SET
            [TimeStamp] = GETUTCDATE()
        WHERE [VCC] = @VCC
        AND [GroupId] = 'SINGLE_PERM_' + @Type + '_' + @Element
        AND [Category] = 'CATEG_GROUP_' + @Type

        IF @@ROWCOUNT = 0
            INSERT INTO [RolePermissionsGroup] (
                [VCC], [GroupId], [Category],
                [TimeStamp]
            )
            VALUES (
                @VCC, 'SINGLE_PERM_' + @Type + '_' + @Element, 'CATEG_GROUP_' + @Type,
                GETUTCDATE()
            )

	END TRY
	BEGIN CATCH

        SET @Result = 0

	END CATCH

    SELECT @Result AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
