SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE PROCEDURE [dbo].[SaveTag]
(
	@VCC						VARCHAR(50),
	@AudioId					VARCHAR(50),
	@Section					NUMERIC(5, 0),
	@Part						NUMERIC(5, 0),
	@Tag						VARCHAR(50),
	@CurrentTime				FLOAT,
	@Comment					VARCHAR(200),
	@CreatedDate				DATETIME,
	@CreatedByUserId			VARCHAR(50),
	@LastModifiedDate			DATETIME,
	@LastModifiedByUserId		VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [dbo].[Tag] SET
		[Comment] = @Comment,
		[LastModifiedDate] = @LastModifiedDate,
		[LastModifiedByUserId] = @LastModifiedByUserId,
		[TimeStamp] = GETUTCDATE()
	WHERE
		[VCC] = @VCC AND
		[AudioId] = @AudioId AND
		[Section] = @Section AND
		[Part] = @Part AND
		[Tag] = @Tag AND
		[CurrentTime] = STR(@CurrentTime, 18, 18)

	IF @@ROWCOUNT = 0
	BEGIN
		BEGIN
			IF EXISTS (
			SELECT * FROM UniqueTag (NOLOCK)
			WHERE [VCC] = @VCC
			AND [TagName] = @Tag
			)
			BEGIN
				SELECT 1 AS 'result'
			END
			ELSE
			BEGIN
				INSERT INTO [dbo].[UniqueTag](
					[VCC],
					[TagName],
					[CreatedDate],
					[CreatedByUserId],
					[TimeStamp]
				)
				VALUES(
					@VCC,
					@Tag,
					@CreatedDate,
					@CreatedByUserId,
					GETUTCDATE()
				)
			END
		END
		BEGIN
			INSERT INTO [dbo].[Tag](
				[VCC],
				[AudioId],
				[Section],
				[Part],
				[Tag],
				[CurrentTime],
				[Comment],
				[CreatedDate],
				[CreatedByUserId],
				[TimeStamp]
			)
			VALUES(
				@VCC,
				@AudioId,
				@Section,
				@Part,
				@Tag,
				STR(@CurrentTime, 18, 18),
				@Comment,
				@CreatedDate,
				@CreatedByUserId,
				GETUTCDATE()
			)
		END
	END

	 SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
