SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO
CREATE PROCEDURE [dbo].[SaveVccLicense] (
	@VCC Varchar(50) = NULL, 					@Product Varchar(50) = NULL,				@Status bit = NULL,
	@CreatedDate Datetime = NULL,				@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,			@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [VCCLicense]
	SET [Product] = @Product,
		[Status] = @Status,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END
	WHERE [VCC] = @VCC AND [Product]=@Product

    IF @@ROWCOUNT = 0
		INSERT INTO [VCCLicense] (
			[VCC], [Product], [Status], [CreatedDate],
			[CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId]
			)
		VALUES (
			@VCC, @Product, @Status, @CreatedDate,
			@CreatedByUserId, @LastModifiedDate, @LastModifiedByUserId
		)
		
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

GO
